#include "debug.h"
#include "proto.h"

void reboot()
{
  static const unsigned char next_op_cmd[] = {
    1, /* version */
    16, /* header size */
    0, 0, /* reserved */
    0, 0, 0, 16, /* payload size */
    0, 5, /* set next operation */
    0, 0, /* reserved */
    0, 0, 0, 0, /* request tag */

    2, /* version */
    2, /* reboot */
    0, /* no gos id */
    0, /* reserved */
    0, 0, 0, 0, /* wake source */
    0, 0, 0, 0, 0, 0, 0, 0 /* reserved */
  };

  static const unsigned char req_shutdown_cmd[] = {
    1, /* version */
    16, /* header size */
    0, 0, /* reserved */
    0, 0, 0, 16, /* payload size */
    0, 1, /* request */
    0, 0, /* reserved */
    0, 0, 0, 0, /* request tag */

    1, /* version */
    1, /* shutdown */
    0, /* myself */
    0, 0, 0, 0, 0, /* reserved */
    0, 0, 0, 0, 0, 0, 0, 0 /* reserved */
  };

  static const unsigned char ack_response[] = {
    1, /* version */
    16, /* header size */
    0, 0, /* reserved */
    0, 0, 0, 16, /* payload size */
    0, 2, /* response */
    0, 0, /* reserved */
    0, 0, 0, 0, /* request tag */

    1, /* version */
    0, 0, 0, /* reserved */
    0, /* ACK */
    0, 0, 0, /* reserved */
    0, 0, 0, 0, 0, 0, 0, 0 /* reserved */
  };

  unsigned char buf[32];

  vuart_write(2, next_op_cmd, sizeof(next_op_cmd));
  vuart_write(2, req_shutdown_cmd, sizeof(req_shutdown_cmd));

  /* wait for the shutdown command */
  vuart_read(2, buf, 32, 1000000);

  vuart_write(2, ack_response, sizeof(ack_response));
  DBG("Shutdown acked, sleeping...\n");
  sleep(5);
  lv1_panic(1);
  for(;;);
}
